## ros-kinetic-rc-genicam-driver 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(rc_genicam_driver)
include(cmake/project_version.cmake)

# - Configuration for code optimization -

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELEASE CACHE STRING "Build type: DEBUG or RELEASE" FORCE)
endif ()

# - Standard definitions -

add_definitions(-Wno-unknown-pragmas)
add_definitions(-Wall)
if (${CMAKE_VERSION} VERSION_LESS "3.1.0")
  add_definitions(-std=c++11)
else ()
  set(CMAKE_CXX_STANDARD 11)
endif ()
# add a target to generate API documentation with Doxygen

add_subdirectory(doc)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  nodelet
  roscpp
  rc_common_msgs
  sensor_msgs
  image_transport
  dynamic_reconfigure
  geometry_msgs
  message_generation
)

## Generate services in the 'srv' folder
#add_service_files(
#    FILES
#)

## Generate added messages and services with any dependencies listed here
#generate_messages(
#        DEPENDENCIES
#)

## System dependencies are found with CMake's conventions
find_package(RC_GENICAM_API 2.3.0 REQUIRED)

#########################################
## Definitions for dynamic reconfigure ##
#########################################

generate_dynamic_reconfigure_options(cfg/rc_genicam_driver.cfg)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES rc_stereocamera
  CATKIN_DEPENDS nodelet roscpp sensor_msgs geometry_msgs rc_common_msgs
#  DEPENDS
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  ${catkin_INCLUDE_DIRS}
  ${RC_GENICAM_API_INCLUDE_DIRS}
)

add_subdirectory(src)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
        rc_genicam_driver_nodelet.xml
        README.md
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
        )

######################################
## Define information for packaging ##
######################################
# optionally specify dependencies of the debian package here (comma separated!)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "rc-genicam-api (>= 2.3.0) | ros-$ENV{ROS_DISTRO}-rc-genicam-api (>= 2.3.0), ros-$ENV{ROS_DISTRO}-image-pipeline")

include(cmake/package_debian.cmake)

=== doc/CMakeLists.txt ===
# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(rc_genicam_driver_doc
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating API documentation with Doxygen" VERBATIM
  )
else(DOXYGEN_FOUND)
  add_custom_target(rc_genicam_driver_doc
      echo "Can't build docs without doxygen installed." && exit 1
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating API documentation with Doxygen" VERBATIM
  )
endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===

set(SRC
    genicam_device_nodelet.cpp
    publishers/camera_info_publisher.cpp
    publishers/camera_param_publisher.cpp
    publishers/image_publisher.cpp
    publishers/disparity_publisher.cpp
    publishers/disparity_color_publisher.cpp
    publishers/depth_publisher.cpp
    publishers/confidence_publisher.cpp
    publishers/error_disparity_publisher.cpp
    publishers/error_depth_publisher.cpp
    publishers/points2_publisher.cpp
    publishers/genicam2ros_publisher.h)

# build and install the nodelet

link_directories(${RC_GENICAM_API_LIBRARY_DIRS})

add_library(rc_genicam_driver_nodelet ${SRC})

target_link_libraries(rc_genicam_driver_nodelet
  PUBLIC
    ${catkin_LIBRARIES}
  PRIVATE
    rc_genicam_api::rc_genicam_api
    ${RC_DYNAMICS_API_LIBRARIES})

add_executable(rc_genicam_driver genicam_device_node.cpp)
target_link_libraries(rc_genicam_driver ${catkin_LIBRARIES})

install(TARGETS rc_genicam_driver rc_genicam_driver_nodelet
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

add_dependencies(rc_genicam_driver_nodelet rc_genicam_driver_gencfg)

=== debian/changelog ===
ros-kinetic-rc-genicam-driver (0.5.0-1xenial) xenial; urgency=high

  * Publish images without filtering on image_rect(_color) topics

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 19 Nov 2020 23:00:00 -0000

ros-kinetic-rc-genicam-driver (0.4.0-1xenial) xenial; urgency=high

  * Added new parameter depth_double_shot

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 19 Nov 2020 23:00:00 -0000

ros-kinetic-rc-genicam-driver (0.3.0-1xenial) xenial; urgency=high

  * Renaming of adaptive_out1_reduction to out1_reduction
  * Added new auto exposure mode Out1High
  * Added reporting test flag, out1 reduction and brightness in camera parameter messages
  * Update README

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 12 Nov 2020 23:00:00 -0000

ros-kinetic-rc-genicam-driver (0.2.0-1xenial) xenial; urgency=high

  * Removed parameter disprange and controlling disparity range via mindepth and maxdepth
  * Changed log output from ROS_ to NODELET_

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 22 Sep 2020 22:00:00 -0000

ros-kinetic-rc-genicam-driver (0.1.0-1xenial) xenial; urgency=high

  * Initial stable release, based on rc_visard_driver

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Jul 2020 22:00:00 -0000

=== debian/control ===
Source: ros-kinetic-rc-genicam-driver
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), curl, libcurl4-openssl-dev, libprotobuf-dev, libprotoc-dev, protobuf-compiler, ros-kinetic-catkin, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-nodelet, ros-kinetic-rc-common-msgs (>= 0.5.0), ros-kinetic-rc-genicam-api (>= 2.3.0), ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf
Homepage: http://wiki.ros.org/rc_visard_driver
Standards-Version: 3.9.2

Package: ros-kinetic-rc-genicam-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libcurl4-openssl-dev, libprotobuf9v5, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-runtime, ros-kinetic-nodelet, ros-kinetic-rc-common-msgs (>= 0.5.0), ros-kinetic-rc-genicam-api (>= 2.3.0), ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf
Description: The rc_genicam_driver provides data from a Roboception rc_visard 3D sensor or rc_cube on several ROS topics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-rc-genicam-driver//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
